/**
 * 注册 字段验证
 * @param validateData
 */
function register(validateData) {


    if (validateData.idCard.state && validateData.phone.state && validateData.smgCode.state) {
        //身份证号、手机号、短信验证码   是否符合标准
        common.log("register---idCard===", validateData.idCard.cValue);
        common.log("register---phone===", validateData.phone.cValue);
        common.log("register---smgCode===", validateData.smgCode.cValue);
        registerExporter(validateData.idCard.cValue, validateData.phone.cValue, validateData.smgCode.cValue);
        //TODO registerExporter 请求注册接口
    } else {
        apiModelStore.apiToast('请按照要求填写字段');
    }
}

function registerExporter(idCard, phone, smgCode) {

    kit.post("92003", {
        zjhm: idCard,
        code: smgCode,
        lxdh: phone,
    }, function (ret) {
        console.log("92003======" + JSON.stringify(ret))
    })
}


/**
 * 登录 字段验证
 * @param validateData
 */
function login(username, password) {
    /*    console.log(username)
        console.log(password)
        newUser.setToken("sdfsdfsdfsdfsdfsdff");
        newUser.setPassword("password");
        newUser.setUserType("admin");
        apiModelStore.apiSendEvent("userTypeChange",'admin');
        apiModelStore.apiIndexOpenWIn("index", "widget://html/index_admin.html");

        return;*/


    loginExporter(username, password);

}

/**
 * 登录
 * @param username
 * @param password
 */
function loginExporter(username, password) {

    kit.post(90001, {
        username: username,
        password: password
    }, function (ret) {
        console.log("loginExporter" + ret)
        var token = ret;

        newUser.setToken(token);
        newUser.setPassword(password);
        newUser.setUserType("admin");

        apiModelStore.apiSendEvent("refreshMatrix");
        //用户信息
        appparameter();

    })
}

//获取App参数信息:90002
function appparameter() {
    kit.post(90002, {}, function (ret) {
        console.log("获取App参数信息:90002==" + JSON.stringify(ret))
        //User.setId(ret.userId);
        //User.setTel(ret.userId);
        newUser.setId(ret.userId);

        personInfo(function (ret) {
            if (ret) {
                apiModelStore.apiSendEvent("myLocationStart");
                if ($api.getStorage("wtf")) {
                    api.closeWin({
                        name: 'index_admin'
                    });
                    apiModelStore.apiIndexOpenWIn("index_admin", "widget://html/index_admin.html");
                } else {
                    apiModelStore.apiIndexOpenWIn("index_admin", "widget://html/index_admin.html");
                }
            } else {
                // alert('用户信息获取失败')
                apiModelStore.apiToast("用户信息获取失败");
            }

        });
    })
}

/**
 * 获取个人信息
 */
function personInfo(callback) {
    // apiModelStore.loadProgress().open();
    //获取个人信息
    kit.post(90004, {}, function (ret) {
        var photo = ret.photo;
        var photoImg = global.ip + ":" + global.port + global.prefix + photo;
        newUser.setImage(photoImg);
        newUser.setGroupId(ret.groupId);
        newUser.setName(ret.name);
        newUser.setUserName(ret.userName);
        newUser.setWgmc(ret.wgmc);
        newUser.setGroupName(ret.groupName);
        apiModelStore.apiSendEvent("image_initData");

        console.log(new Date() + "==90004==" + JSON.stringify(ret));
        callback(ret);

        // apiModelStore.loadProgress().close();
    })
}

var _admin = {
    "id": "15581584114",
    "name": "管理员",
    "wgmc": "",
    "groupId": "297e0339679c6f3a01679c95c16e0005",
    "groupName": "盐池县",
    "image": "http://192.168.1.106:8003/zhzlpt/view/resource/upload/picture/personal/f7fb1321-ebf9-4b25-b044-c0600a653057.jpg",
    "userType": "admin",
    "password": "123456"
};
var _lc = {
    "wgmc": "麻黄山村社区第一网格",
    "password": "123456",
    "id": "15581584114",
    "image": "http:\/\/192.168.1.106:8003\/zhzlpt\/view\/resource\/upload\/picture\/personal\/DA1814B2A8DBA1A821FDB340764C53F7.jpg",
    "groupName": "麻黄山村委会",
    "groupId": "2c9ec0056cad83d9016cd6cb9a47056b",
    "name": "lc",
    "userType": "admin"
};

/**
 * 退出登录
 */
function logout(type) {
    /*newUser.clear();
    apiModelStore.apiSendEvent("userTypeChange",'dz');
    apiModelStore.apiIndexOpenWIn("index", "widget://html/index_dz.html");*/

    if (newUser.getUserType() == 'admin') {
        kit.post(90003, {}, function (ret) {
            if (ret != "" || ret == null) {
                newUser.clear();
                apiModelStore.apiToast("退出成功！");

                apiModelStore.apiSendEvent("userTypeChange", 'dz');
                apiModelStore.apiSendEvent("myLocationStop");
                /* api.closeWin({
                     name: 'login_win'
                 });*/
                /* api.closeWin({
                     name: 'index_admin'
                 });*/
                apiModelStore.apiIndexOpenWIn("index_dz", "widget://html/index_dz.html");
            }
        })
    } else {
        newUser.clear();
        apiModelStore.apiIndexOpenWIn("index_dz", "widget://html/index_dz.html");
        apiModelStore.apiSendEvent("userTypeChange", 'dz');
        // apiModelStore.apiIndexOpenWIn("index", "widget://html/index_dz.html");

        apiModelStore.apiToast("退出成功！");
    }


}

/**
 * 上传头像
 */
function upUserImage() {
    toChangeUserImage(function (path) {
        if ("" != path && null != path && undefined != path) {
            //网络请求
            console.log("path===========" + path);

            //上传附件
            kit.uploadFunction({
                files: path,
                fileType: 'personal'
            }, function (ret) {

                console.log(JSON.stringify(ret));
                console.log((ret[0].fileName));

                //修改头像
                kit.post(90007, {
                    fileName: ret[0].fileName
                }, function (ret) {
                    if (ret.success == true) {
                        console.log(kit.toJSON(ret));

                        //todo 更新：User
                        personInfo(function (ret) {
                            if (ret) {
                                var photo = ret.photo;
                                var photoImg = global.ip + ":" + global.port + global.prefix + photo;


                            }
                        });

                    }
                })
            })
        } else {
            console.log("path=========== 图片选择失败");
        }
    });
}

/**
 * 选择头像 方式
 * @param callback
 */
function toChangeUserImage(callback) {
    apiModelStore.apiActionSheet("changeUserImage", null, null, function (ret, err) {
        console.log(JSON.stringify(ret));
        if ("1" == ret.buttonIndex) {
            apiModelStore.permissions("camera").HasPermission(function (ret) {
                if (ret) {

                    //拍照
                    apiModelStore.apiGetPicture('pic', function (ret, err) {
                        console.log("拍照========" + JSON.stringify(ret));
                        callback(ret.data);
                    })
                } else {
                    apiModelStore.apiToast("放弃该权限")

                }

            });


        } else if ("2" == ret.buttonIndex) {
            //系统相册
            //todo 微信端的方法 没有写
            apiModelStore.modelSelectImage(1, function (ret) {
                callback(ret.list[0].path);
            })

        }


    })
}

/**
 * 获取日志列表
 */
function OpenJournalList(callback) {

    kit.post(70001, {
        /*  pageCurrent: pageNum,
          pageSize: pageSize,*/
        pageCurrent: 1,
        pageSize: 999,
    }, function (ret) {
        console.log("journalList====" + JSON.stringify(ret));

        if (ret.length > 0) {
            callback(ret);
        } else {
        }
    })
}

/**
 * 获取日志详情
 */
function OpenJournalDetails(id, callback) {

    /* callback({
         content:"水电费水电费水电费水电费水电费水电费水电费水电费水电费水电费水电费水电费水电费水电费水电费水电费",
         title:"水电费水电费",
         time:"2019年7月24日00:11:19"

     });*/
    kit.post(70003, {
        objId: id,
    }, function (ret) {
        console.log(JSON.stringify(ret))
        callback(ret);

    });
}

/**
 * 验证 并  提交日志
 */
function commitJournal(validateData) {
    console.log(JSON.stringify(validateData))
    if (validateData.journalTitle.state && validateData.journalContent.state) {


        kit.post(70002, {
            title: validateData.journalTitle.cValue,
            content: validateData.journalContent.cValue
        }, function (ret) {
            apiModelStore.apiToast("提交成功");
            apiModelStore.apiSendEvent('journalList_initData', {});
            apiModelStore.goBack();

        });
    } else {

        apiModelStore.apiToast("提交失败:提交内容" + validateData.journalTitle.describe);
    }

}

function OpenMaterial() {

}

function changePassword(validateData) {
    console.log("===============================");
    console.log(new Date() + "====" + JSON.stringify(validateData));
    console.log("===============================");
    if (validateData.passWordOld.state && validateData.passWordNew.state && validateData.passWordNewA.state && validateData.imageCode.state) {
        var params = {
            originPassowrd: validateData.passWordOld.cValue,
            newPassword: validateData.passWordNew.cValue,
            token: newUser.getToken(),
        };
        kit.post(90006, params, function (ret) {
            apiModelStore.apiToast("修改成功");
            // $api.rmStorage('token');
            //重新存储密码
            //newUser.setPassword(validateData.passWordNew.cValue);
            //重新登录
            loginExporter(newUser.getUserName(), validateData.passWordNew.cValue);
            //apiModelStore.goBack();
        });
    } else {
        apiModelStore.apiToast("请按照要求填写相关内容！");
    }
}

/**
 * 天气数据
 * @param callback
 */
function weatherType(weatherTypes, callback) {
    var weatherTypes = weatherTypes;

    this.chooseImg = function (str) {

        if (str == "晴") {
            return "../../image/weather/weather_top_qing.png";
        } else if (str == "多云" || str == "晴间多云" || str == "少云") {
            return "../../image/weather/weather_top_duoyun.png";
        } else if (str == "阴") {
            return "../../image/weather/weather_top_yin.png";
        } else if (str == "有风") {
            return "../../image/weather/weather_top_leiyu.png";
        } else if (str == "平静") {
            return "../../image/weather/weather_top_leiyu.png";
        } else if (str == "微风") {
            return "../../image/weather/weather_top_leiyu.png";
        } else if (str == "和风") {
            return "../../image/weather/weather_top_leiyu.png";
        } else if (str == "清风") {
            return "../../image/weather/weather_top_leiyu.png";
        } else if (str == "强风/劲风") {
            return "../../image/weather/weather_top_leiyu.png";
        } else if (str == "疾风") {
            return "../../image/weather/weather_top_leiyu.png";
        } else if (str == "大风") {
            return "../../image/weather/weather_top_leiyu.png";
        } else if (str == "烈风") {
            return "../../image/weather/weather_top_leiyu.png";
        } else if (str == "风暴") {
            return "../../image/weather/weather_top_leiyu.png";
        } else if (str == "狂爆风") {
            return "../../image/weather/weather_top_leiyu.png";
        } else if (str == "飓风") {
            return "../../image/weather/weather_top_leiyu.png";
        } else if (str == "热带风暴") {
            return "../../image/weather/weather_top_leiyu.png";
        } else if (str == "龙卷风") {
            return "../../image/weather/weather_top_leiyu.png";
        } else if (str == "阵雨" || str == "小雨" || str == "中雨" || str == "雷阵雨并伴有冰雹" || str == "大雨" || str == "暴雨" || str == "大暴雨" ||
            str == "特大暴雨" || str == "强阵雨" || str == "强雷阵雨" || str == "极端降雨" || str == "毛毛雨/细雨" || str == "小雨-中雨" ||
            str == "中雨-大雨" || str == "大雨-暴雨" || str == "暴雨-大暴雨" || str == "大暴雨-特大暴雨" || str == "雨雪天气" || str == "雨夹雪" ||
            str == "阵雨夹雪" || str == "冻雨") {
            return "../../image/weather/weather_top_dayu.png";
        } else if (str == "雷阵雨") {
            return "../../image/weather/weather_top_leiyu.png";
        } else if (str == "雪") {
            return "../../image/weather/weather_top_xue.png";
        } else if (str == "阵雪") {
            return "../../image/weather/weather_top_xue.png";
        } else if (str == "小雪") {
            return "../../image/weather/weather_top_xue.png";
        } else if (str == "中雪") {
            return "../../image/weather/weather_top_xue.png";
        } else if (str == "大雪") {
            return "../../image/weather/weather_top_xue.png";
        } else if (str == "暴雪") {
            return "../../image/weather/weather_top_xue.png";
        } else if (str == "小雪-中雪") {
            return "../../image/weather/weather_top_xue.png";
        } else if (str == "中雪-大雪") {
            return "../../image/weather/weather_top_xue.png";
        } else if (str == "大雪-暴雪") {
            return "../../image/weather/weather_top_xue.png";
        } else if (str == "浮尘") {
            return "../../image/weather/weather_top_shancheng.png";
        } else if (str == "扬沙") {
            return "../../image/weather/weather_top_shancheng.png";
        } else if (str == "沙尘暴") {
            return "../../image/weather/weather_top_shancheng.png";
        } else if (str == "强沙尘暴") {
            return "../../image/weather/weather_top_shancheng.png";
        } else if (str == "雾") {
            return "../../image/weather/weather_top_fog.png";
        } else if (str == "浓雾") {
            return "../../image/weather/weather_top_fog.png";
        } else if (str == "强浓雾") {
            return "../../image/weather/weather_top_fog.png";
        } else if (str == "轻雾") {
            return "../../image/weather/weather_top_fog.png";
        } else if (str == "大雾") {
            return "../../image/weather/weather_top_fog.png";
        } else if (str == "特强浓雾") {
            return "../../image/weather/weather_top_fog.png";
        } else if (str == "霾") {
            return "../../image/weather/weather_top_feng.png";
        } else if (str == "中度霾") {
            return "../../image/weather/weather_top_feng.png";
        } else if (str == "重度霾") {
            return "../../image/weather/weather_top_feng.png";
        } else if (str == "严重霾") {
            return "../../image/weather/weather_top_feng.png";
        } else if (str == "热") {
            return "../../image/weather/weather_top_xue.png";
        } else if (str == "冷") {
            return "../../image/weather/weather_top_qing.png";
        } else {
            return "../../image/weather/weather_top_qing.png";
        }


        /*

     晴 少云 晴间多云 多云 阴
     有风 平静 微风 和风 清风 强风/劲风 疾风 大风 烈风  风暴 狂爆风 飓风 热带风暴
     阵雨 雷阵雨  雷阵雨并伴有冰雹 小雨 中雨 大雨 暴雨 大暴雨 特大暴雨 强阵雨 强雷阵雨 极端降雨 毛毛雨/细雨 雨 小雨-中雨 中雨-大雨 大雨-暴雨 暴雨-大暴雨 大暴雨-特大暴雨
     雨雪天气 雨夹雪 阵雨夹雪 冻雨 雪 阵雪 小雪 中雪 大雪 暴雪 小雪-中雪 中雪-大雪 大雪-暴雪
     浮尘 扬沙 沙尘暴 强沙尘暴 龙卷风
     雾 浓雾 强浓雾 轻雾 大雾 特强浓雾 霾 中度霾 重度霾 严重霾
     热 冷 未知
      */
    };

    callback(this.chooseImg(weatherTypes));
}

/**
 * 本地数据对比 城市id
 *
 * @param province
 * @param name
 * @param callback
 */
function getCityId(province, name, callback) {

    if (province != '宁夏回族自治区') {
        callback(false);
    } else {
        if (appConfig.cityData[name]) {
            callback(appConfig.cityData[name].id);
        } else {
            callback(false);
        }
    }

}

/**
 * 实有人口查询  列表
 * @param xm
 * @param zjhm
 * @param callback
 * @constructor
 */
function realPopulationList(rc, pageN, callback) {
    this.data = {
        pageCurrent: pageN || 1,
        pageSize: 10,
    };
    var _this = this;
    if (rc) {
        var key = Object.keys(rc)
        _this.data[key] = rc[key];

    }


    kit.post(10006, _this.data, function (ret) {
        if (ret.length > 0) {
            callback(ret);
        } else {
            callback([]);
        }
    })
}


/**
 * 针对select下拉框设计的获取数据字典的公共方法，传select的id和数据字典的simpleName
 * @param {Object} id select的id
 * @param {Object} simpleName 数据字典的简称
 */
function dataDictionary(simpleName, callback) {
    if (simpleName == null || simpleName == 'null' || simpleName == '') {
        alert("dataDictionary数据异常，simpleName不能为空，错误simpleName为：" + simpleName);
        callback([]);

    } else {
        //数据字典接口列表:90005
        kit.post(90005, {
            simpleName: simpleName
        }, function (ret) {

            callback(ret);
        })
    }
}
