/* ↓↓↓↓   用户信息  ↓↓↓↓*/
var myUserBean = function () {

    this.setId = function (id) {
        $api.setStorage("id", id);
    };
    this.getId = function () {
        return $api.getStorage("id");
    };
    this.setUserType = function (userType) {
        $api.setStorage("userType", userType);
    };
    this.getUserType = function () {
        return $api.getStorage("userType");
    };
    this.setIdCard = function (idCard) {
        $api.setStorage("idCard", idCard);
    };
    this.getIdCard = function () {
        return $api.getStorage("idCard");
    };

    this.setName = function (name) {
        $api.setStorage("name", name);
    };
    this.getName = function () {
        return $api.getStorage("name");
    };
    this.setUserName = function (userName) {
        $api.setStorage("userName", userName);
    };
    this.getUserName = function () {
        return $api.getStorage("userName");
    };
    this.setPassword = function (password) {
        $api.setStorage("password", password);
    };
    this.getPassword = function () {
        return $api.getStorage("password");
    };

    this.setTel = function (tel) {
        $api.setStorage("tel", tel);
    };
    this.getTel = function () {
        return $api.getStorage("tel");
    };
    this.setGroupName = function (groupName) {
        $api.setStorage("groupName", groupName);
    };
    this.getGroupName = function () {
        return $api.getStorage("groupName");
    };

    this.setGroupId = function (groupId) {
        $api.setStorage("groupId", groupId);
    };
    this.getGroupId = function () {
        return $api.getStorage("groupId");
    };
    this.setImage = function (image) {
        $api.setStorage("image", image);
    };
    this.getImage = function () {
        return $api.getStorage("image");
    };

    this.setToken = function (token) {
        $api.setStorage("token", token);
    };
    this.getToken = function () {
        return $api.getStorage("token");
    };

    this.setWgmc = function (wgmc) {
        $api.setStorage("wgmc", wgmc);
    };
    this.getWgmc = function () {
        return $api.getStorage("wgmc");
    };
    this.clear = function () {
        $api.rmStorage('id');
        $api.rmStorage('name');
        $api.rmStorage('userName');
        $api.rmStorage('tel');
        $api.rmStorage('wgmc');
        $api.rmStorage('groupId');
        $api.rmStorage('groupName');
        $api.rmStorage('image');
        $api.rmStorage('token');
        $api.rmStorage('userType');
        $api.rmStorage('password');
        $api.rmStorage('idCard');
    };
    this.getData = function () {
        var dd = {
            id: this.getId(),
            name: this.getName(),
            userName:this.getUserName(),
            tel: this.getTel(),
            wgmc: this.getWgmc(),
            groupId: this.getGroupId(),
            groupName: this.getGroupName(),
            image: this.getImage(),
            token: this.getTel(),
            userType: this.getUserType(),
            idCard: this.getIdCard(),
            password: this.getPassword(),
        };
        return dd;
    };
    this.read = function () {
        if ($api.getStorage('token')) {
            return true;
        }
        return false;

    };
    return this;
};
var newUser = myUserBean();


/* ↑↑↑↑↑↑  用户信息  ↑↑↑↑↑↑*/

/*↓↓↓↓     myVue对象    ↓↓↓↓*/
var myVueObj = function (el, data, methods) {
    // vueComponent();
    methods = methods || {};
    var dataes = {
        testV: false,
        isWX: appConfig.isWX,
        //微信端 是否会跨域
        isCrossDomain: appConfig.isCrossDomain,
        appVersion: appConfig.version,
        isLogin: newUser.read()?newUser.read():false,
        userType: newUser.getUserType()?newUser.getUserType() :'dz',//用户类型
        imageBaseUrl: appConfig.net.ip + ':' + appConfig.net.port + appConfig.net.prefix,
        defaultImage: appConfig.defaultImage,
        uploadUrl: appConfig.net.ip + ":" + appConfig.net.port + appConfig.net.prefix + "/api/upload",
        userImage: '../../image/loading_more.gif',
        userInfo: newUser.getData(),
        qx:newUser.getData().wgmc==''?true:false,
        pageData: {
            params: {},
            data: data || {},
        },
        pagesData: {}, // 使用Vue.set 方法注入响应式属性
        pageCurrent: 1,
        weatherData: "",
        validateData: appConfig.validateConfig,
        page: { // 分页控制
            pageSize: 5,
            pageNow: 1
        },

        appName: appConfig.appName,
        appFragmentName: appConfig.appFragment,

        imageFile: {
            choseImageArr: [],//选择的图片数组
            upImagePathArr: [],//开始上传按钮
            retData: [],//上传成功后 返回的数据
        },
        transType: [
            { "name": "基础应用" },
            { "name": "网格管理" },
            { "name": "事件管理" }
        ],
    };

    var m = {
        JsonToString: function (s) {
            return JSON.stringify(s);
        },

        inputV: function (name) {
            function stateTF(__this, s) {
                if (s) {
                    __this.state = true;
                } else {
                    __this.state = false;
                    apiModelStore.apiToast(__this.tip);
                }
            }

            var _this = this.validateData[name];

            if ("" == _this.cValue) {
                _this.state = false;
                apiModelStore.apiToast(_this.dValue);
            } else {
                if ("userName" == name) {
                    //todo 验证
                    validateUserName(_this.cValue, function (s) {
                        stateTF(_this, s)
                    })
                } else if ("idCard" == name) {
                    validateIdNo(_this.cValue, function (s) {
                        stateTF(_this, s)
                    })
                } else if ("smgCode" == name) {
                    validateSmgCode(_this.cValue, function (s) {
                        stateTF(_this, s)
                    })
                } else if ("passWord" == name) {
                    validateUserName(_this.cValue, function (s) {
                        stateTF(_this, s)
                    })
                } else if ("journalTitle" == name) {
                    validateJournal(_this.cValue, function (s) {
                        stateTF(_this, s)
                    })
                } else if ("phone" == name) {
                    validatePhone(_this.cValue, function (s) {
                        stateTF(_this, s)
                    })
                } else if ("email" == name) {
                    validateEMail(_this.cValue, function (s) {
                        stateTF(_this, s)
                    })
                } else if ("journalContent" == name) {
                    validateJournal(_this.cValue, function (s) {
                        stateTF(_this, s)
                    })
                } else if ("passWordOld" == name) {
                    validateUserName(_this.cValue, function (s) {
                        stateTF(_this, s)
                    })
                } else if ("passWordNew" == name) {
                    validateUserName(_this.cValue, function (s) {
                        stateTF(_this, s)
                    })
                } else if ("passWordNewA" == name) {
                    validateUserName(_this.cValue, function (s) {
                        stateTF(_this, s)
                    })
                } else if ("imageCode" == name) {
                    validateUserName(_this.cValue, function (s) {
                        stateTF(_this, s)
                    })
                }
            }

        },

        ApiOpenWin: function (winName, pageParams) {
            if (!winName) {
                apiModelStore.apiToast('模块暂未开发');
                return;
            }
            apiModelStore.apiOpenWin(winName, pageParams);
        },
        GoBack: function () {
            apiModelStore.goBack();
        },
        ImageSelect: function () {
            apiModelStore.modelSelectImage();
        }, SelectFile: function () {
            apiModelStore.modelSelectFile();
        },
        ByteFormatSize: function (size) {
            return common.byteFormatSize(size)
        },
        DialogBox_alert1: function () {
            apiModelStore.dialogBox_alert1("", "", function (ret) {
                console.log(ret)
            });
        },
        MomentFormat: function (Format, time) {
            return myMoment.momentFormat(Format, time);
        },
        MomentFromNow: function (time) {
            //  '2017-5-20'
            return myMoment.momentFromNow(time);
        }, MomentFromOther: function (time) {
            // "20191016103551"
           // "2019-11-07 10:46:31"

            var newTime=time.substring(0,4)+
                '-'+
                time.substring(4,6)+
                '-'+
                time.substring(6,8)+
                ' '+
                time.substring(8,10)+
                ':'+
                time.substring(10,12)+
                ':'+
                time.substring(12,14)
            ;
            return  newTime ;
        },

        FnKeyFrame: function () {
            apiModelStore.fnKeyFrame();

        },
        FnCloseKeyFrame: function () {
            apiModelStore.fnCloseKeyFrame();
        },
        DataHtmlFormat: function (string) {

            var ch = '<img src="';
            var val = string.replace(new RegExp(ch, 'g'), '<img src="' + appConfig.net.ip + ':' + appConfig.net.port);
            //console.log(val);
            return val;
        },
        //操作状态码
        operationStateCode: function (stateCode) {
            return operationStateCode(stateCode);
        },
        //事件状态码
        eventStateCode: function (stateCode) {
            return eventStateCode(stateCode);
        },
        // 图片加载失败事件    @error
        imageError: function (el) {
            el.target.src = '../../icon/none.jpg';
        },
        /**
         * 统一获取参数
         *
         * @param {*} parameter 传递进入参数数组
         * 格式 : 
         * {
         *      name: '',           // 在界面上显示的文字或数据
         *      value: '',          // 需要上传或传递的数据
         *      cname: '',          // 提示的时候需要显示的文字
         *      checked: '',        // 校验规则 require | idCard | phone 竖线分割
         *      linkage: '',        // 联动字段, 唯一值
         *      linkage_val: '',    // 被联动字段值 (若与被联动字段值相等则进行校验判断), 竖线分割, 可能和多个字短联动
         *      type: '',           // 当前数据在界面上表现类型 空: 输入框, select: 选择弹窗, date: 日期选择框
         *      placeholder: ''     // input: placeholder
         * }
         * 
         * @returns
         */
        getParameter: function (parameter) {
            var _this = this;
            var par = {}; // 返回的参数
            var noData = []; // 必填项为空统计
            var checked = true; // 是否成功校验

            var msg = '';

            $.each(parameter, function (key, val) {
                var checkedArr = val.checked ? val.checked.split('|') : []; // 获取所有校验规则
                var linkage = val.linkage ? val.linkage : ''; // 获取联动字段
                var linkageValArr = val.linkage_val ? val.linkage_val.split('|') : []; // 获取联动数据
                var cname = val.cname;
                var value = val.value;
                var linkage_val_now = ''; // 保存当前联动字段当前值 

                if (linkage) {
                    linkage_val_now = parameter[linkage].value;
                }

                // 判断是否为必填项
                // if (
                //     (!linkage || (linkageValArr.indexOf(linkage_val_now) != -1)) &&
                //     checkedArr.indexOf('require') != -1 &&
                //     !(value || typeof value == 'number')
                // ) {
                //     noData.push(cname);
                //     checked = false;
                // }

                // 校验其他规则
                if(
                    (!linkage || (linkageValArr.indexOf(linkage_val_now) != -1)) 
                ){
                    $.each(checkedArr, function(i, check){
                        if(
                            check == 'require' && 
                            !(value || typeof value == 'number')
                        ){
                            noData.push(cname);
                            checked = false;
                        }else{
                            var checkResult = kit.check(check, value);
                            if (!checkResult.pass) {
                                msg = cname + checkResult.tip;
                                checked = false;
                                return false;
                            }
                        }
                    });
                }

                par[key] = value;
            });

            if (checked) {
                return par;
            } else {
                if(msg){
                    apiModelStore.apiToast(msg);
                }else if (noData.length) {
                    apiModelStore.apiToast(noData.join(',') + '为必填项');
                }
                return checked;
            }
        }
    };

    for (var k in methods) {
        m[k] = methods[k];
    }

    var uf = {};

    var _this = this;
    var myVue = new Vue({
        el: el || "#wrap",
        data: dataes,
        created: function () {

        },
        mounted: function () {
            /* var myImage = new Image();
             myImage.src = newUser.getImage();
             var _this = this;
 
             myImage.onerror = function myOnerror() {
                 // 图片加载错误时的替换图片
                 myImage.src = '../../image/nodata.jpg'
             };
             myImage.onload = function myOnload() {
                 _this.userImage = myImage.src;
             };*/
            /*
            //此写法低版本Android  不支持
            myImage.onerror = () => {
                 // 图片加载错误时的替换图片
                 myImage.src = '../../image/nodata.jpg'
             }
             myImage.onload = () => { // 图片加载成功后把地址给原来的img
                 this.userImage = myImage.src;
             }*/

        },
        methods: m,
        components: data.components, // 组件注入
        computed: {


        },
        watch: {

        }

    });
    return myVue;
};

/*时间选择器*/
var myDateObj = function (el, format, callback) {
    /* 回调函数
    * tips:	在vue及其他mvvm框架中使用时，在confirm中修改v-model绑定的数据即可
    */
    var myDate = new Rolldate({
        el: '#' + el,
        format: format,
        beginYear: 1940,
        endYear: 2050,
        init: function () {
            $('input').blur();
        },
        moveEnd: function (scroll) {
            // console.log(scroll)
            // console.log('滚动结束');
        },
        confirm: function (date) {

            callback(date);
            // console.log(date);
            // console.log('确定按钮触发');
        },
        cancel: function () {
            // console.log('插件运行取消');
        }
    });
    return myDate;
};

var mySwiperObj = function (select) {
    if (!select) {
        select = ".swiper-container";
    }

    var swiper = new Swiper(select, {
        loop: true, //循环播放
        slidesPerView: 3,
        spaceBetween: -30,
        centeredSlides: true,
        autoplay: {
            delay: 2000,
            disableOnInteraction: false,//false: 触碰后自动切换也不会停止
        },
        pagination: {
            el: '.swiper-pagination',
            type: 'fraction',
            renderFraction: function (currentClass, totalClass) {
                return '<span class="' + currentClass + '"></span>' + '/' + '<span class="' + totalClass + '"></span>';
            },
        },
        observer: true,
    });

    return swiper;
};
/**
 * 轮播图动态添加图片
 * @param {*} type add 新增, update 更新, 默认update
 * @param {*} obj swiper 实例化对象
 * @param {*} arr 需要更新的图片数组
 */
var addSlide = function (obj, arr, type) {
    if (!type || type == 'update') {
        obj.removeAllSlides();
    }
    var imu = appConfig.net.ip + ":" + appConfig.net.port + appConfig.net.prefix;
    $.each(arr || [], function (i, val) {
        // console.log(imu + val.bannerImgPath)
        obj.addSlide(0, '<div class="swiper-slide"><img src="' + imu + val.bannerImgPath + '" onerror="common.imgOtherError(this)"></div>')
    });
};


/*↓↓↓↓     基础方法    ↓↓↓↓*/
var common = {
    /**
     * 图片错误
     * @param img
     * @param url
     */
    imgOtherError: function (img, url) {
        img.src = "../../image/nodata.jpg";
        img.onerror = null; //如果错误图片也不存在就会死循环一直跳，所以要设置成null，也可以不加
    },


    /**
     * 描述：日志打印
     * @param name
     * @param string
     */
    log: function (name, string) {
        //描述：日志打印
        function log(name, string) {
            console.log("↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓" + name + "↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓");
            console.log(string);
            console.log("↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑" + name + "↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓");
        }
    },

    /**
     * 沉浸式
     * @param isImmerse 沉浸？
     * @param headerId
     * @param footerId
     * @returns {{footerPosH: (null|*|number), headerPosH: (null|*|number)}|*}
     */
    appStatus: function (isImmerse, headerId, footerId) {
        this.isImmerse = isImmerse;
        this.headerId = headerId;
        this.footerId = footerId;
        this.data = {
            headerPosH: appConfig.headerPosH,//头部高度 默认
            footerPosH: appConfig.footerPosH,//底部高度  默认
        };

        if (null != this.headerId) {
            var headerObj = $api.byId(this.headerId);
            //微信端不用沉浸  ，使用默认高度
            if (this.isImmerse && !myVueObj.isWX) {
                $api.fixStatusBar(headerObj);
                $api.fixIos7Bar(headerObj);
                this.data.headerPosH = ($api.offset(headerObj)).h;
            }
        }
        if (null != this.footerId) {
            var footerObj = $api.byId(this.footerId);
            //微信端不用沉浸  ，使用默认高度
            if (this.isImmerse && !myVueObj.isWX) {
                $api.fixTabBar(footerObj)
                this.data.footerPosH = ($api.offset(footerObj)).h
            }
        }

        return this.data;
    },
    /**
     * 刷新方法
     * @param {*} select 选择器
     * @param {*} callbackBefore 刷新前
     * @param {*} callbackAfter 刷新后
     * @returns
     */
    myPullRefresh: function (select, callbackBefore, callbackAfter) {

        var pullRefresh = new auiPullToRefresh({
            container: document.querySelector(select),
            triggerDistance: 100
        }, function (ret) {
            if (ret.status == "success") {
                if (
                    callbackAfter && typeof callbackAfter == 'function' &&
                    callbackBefore && typeof callbackBefore == 'function'
                ) {
                    callbackBefore();
                }
                setTimeout(function () {
                    //等待优化，分两种：1.刷新页面，2.更新数据
                    try {
                        if (callbackAfter && typeof callbackAfter == 'function') {
                            callbackAfter();
                        } else if (callbackBefore && typeof callbackBefore == 'function') {
                            callbackBefore();
                        } else if (initData && typeof initData == 'function') {
                            initData();
                        }
                    } catch (error) {

                    }
                    pullRefresh.cancelLoading(); //刷新成功后调用此方法隐藏
                }, 500);
            }
        });
        return pullRefresh;
    },

    /*上拉加载更多*/
    myDownLoadMore: function (callback) {
        api.addEventListener({
            name: 'scrolltobottom',
            extra: {
                threshold: 0 //设置距离底部多少距离时触发，默认值为0，数字类型
            }
        }, function (ret, err) {
            console.log(new Date() + "底部");
            if (callback && typeof callback == 'function') {
                callback(true);
            }
        });

    },
    /**
     *  上拉加载更多 不建议
     */
    myDownLoadMore1: function (callback) {
        var scroll = new auiScroll({
            listen: true,
            distance: 0//判断到达底部的距离，isToBottom为true
        }, function (ret) {
            /* console.log(JSON.stringify(ret))*/
            if (ret.isToBottom) {
                callback(true);
            } else {
                callback(false);
            }

        });

    },

    /*  文件大小转化   ['B', 'K', 'M', 'G', 'TB']  */
    byteFormatSize: function (size, pointLength, units) {
        var unit;
        units = units || ['B', 'K', 'M', 'G', 'TB'];
        while ((unit = units.shift()) && size > 1024) {
            size = size / 1024;
        }
        return (unit === 'B' ? size : size.toFixed(pointLength === undefined ? 2 : pointLength)) + unit;
    },

};

/*↓↓↓↓     时间处理组件   ↓↓↓↓*/
var myMoment = {
    /*格式化时间*/
    momentFormat: function (format, time) {
        if ("YMDHMS" == format) {
            return moment(time).format("YYYY-MM-DD HH:mm:ss");
        } else if ("YMD" == format) {
            return moment(time).format("YYYY-MM-DD");
        }

    },
    /*相对时间*/
    momentFromNow: function (time) {
        return moment(time).fromNow();
    },

    /*相对时间*/
    momentFromWeek: function (time) {
        return moment(new Date()).format('dddd');  //星期几
    },
};


/*打开win相对应的frame*/
function winOpenFrame(name, headerPosH, footerPosH) {
    api.openFrame({
        name: name,
        url: "widget://html/" + name + "/" + name + "_frame.html",
        bounces: false,
        rect: {
            marginLeft: 0,    //相对父 window 左外边距的距离
            marginTop: headerPosH,    //相对父 window 上外边距的距离
            marginBottom: footerPosH,    //相对父 window 下外边距的距离
            marginRight: 0    //相对父 window 右外边距的距离
            /*  x: 0,
              y: headerPosH,
              w: 'auto',
              h: api.winHeight - headerPosH - footerPosH,*/
        },
    });

}

/*打开win */

//打开新窗口 dirAndName   ../dir/winname
//checklogin: 1:需要登录才能打开  0:不需要登录就打开
function openNewWin(dirAndName, checklogin, params) {
    //判断是否有参数
    var pageParam = {};
    if (typeof (params) != 'undefined') {
        pageParam = params;
        console.log("openNewWin存在pageparams:" + JSON.stringify(params));
    }
    //判断是否有登陆
    if (checklogin) {
        if (newUser.getToken() == null) {
            api.toast({
                msg: '请先登录！',
                duration: 2000,
                location: 'middle'
            });
            api.openWin({
                name: 'login_win',
                url: "widget://html/login/login_win.html",
            });
            return false;
        }
    }


    //拆分得到winows name
    /* var arr = dirAndName.split('/');
     var name = arr[arr.length - 1];*/
    //alert(name + ':'+dirAndName+'_win.html');
    //alert(name);
    var wName = name + '_win';
    api.openWin({
        name: wName,
        url: "widget://html/" + dirAndName + "/" + dirAndName + "_win.html",

        bounces: false,
        pageParam: pageParam
    });
}


//回到主界面
function backHomeWin() {
    //这个是回到主界面不会回到userwin
    api.closeToWin({
        name: 'root'
    });
}

/**
 * 获取经纬度
 * @param callback
 */
function bMapGetLocation(callback) {
    bMap.getLocation({
        accuracy: '100m',
        autoStop: true,
        enableLocInForeground: true,
        filter: 1,
        notification: {
            id: 1,   //(必选项) 数字类型；为通知栏notifation设置唯一id，必须大于0
            contentTitle: "baidu",//(必选项) 字符串类型；标题
            contentText: "baidu",  //(必选项) 字符串类型；内容
        },
    }, function (ret, err) {
        // console.log(JSON.stringify(ret));
        // console.log(JSON.stringify(err));
        if (ret.status) {
            // console.log(JSON.stringify(ret));
            if (callback) {
                callback(ret);
            } else {
                bMap.setCenter({
                    coords: {
                        lon: ret.lon,
                        lat: ret.lat
                    },
                    animation: false
                });
                //initMap(ret.lon, ret.lat,api.pageParam)
            }
        } else {
            // alert(err.code);
            // console.log(JSON.stringify(err));
            apiModelStore.apiToast('请确认手机是否打开位置信息, 确认打开后请返回重新进入');
        }
    });
}

/**
 * 通过经纬度打开地图
 * @param lon
 * @param lat
 */
function initMap(lon, lat, pageHeaderFooter) {
    // console.log(api.frameName);
    bMap.open({
        rect: {
            marginLeft: 0,    //相对父 window 左外边距的距离
            marginTop: pageHeaderFooter.headerPosH,    //相对父 window 上外边距的距离
            marginBottom: pageHeaderFooter.footerPosH,    //相对父 window 下外边距的距离
            marginRight: 0    //相对父 window 右外边距的距离
        },
        center: {
            lon: lon,
            lat: lat
        },
        //设置百度地图比例尺
        setScaleBar: {
            show: true,
            position: {
                x: 300,
                y: 300
            }
        },
        //设定地图是否显示底图 poi 标注(不包含室内图标注)
        showMapPoi: true,
        //地图等级
        zoomLevel: 15,
        //是否在地图上显示用户位置，会自动移动地图可视区域中心点到用户当前坐标位置，自带地图移动动画效果
        showUserLocation: {
            isShow: true,
            trackingMode: 'follow'
        },
        fixedOn: api.frameName,
        fixed: true
    }, function (ret) {
        if (ret.status) {
            //alert('地图打开成功');
            // initData();
            bMapListener("click");
        }
    });


}

function bMapListener(type) {
    this.type = type;
    if (!type) {
        this.type = "click";
    }
    /*事件监听*/
    /*
    * longPress（长按事件）
    * viewChange（地图视角范围改变事件）
    * click（单击事件）
    * dbclick（双击事件
    * zoom（放大缩小事件）iOS 平台暂不支持此监听
    * */

    /*  */
    bMap.addEventListener({
        name: this.type
    }, function (ret) {
        if (ret.status) {
            // console.log(JSON.stringify(ret))
            //alert(ret.lon+"----------"+ret.lat);

            bMap.setCenter({
                 coords: {
                     lon:ret.lon,
                     lat: ret.lat
                 },
                 animation: false
             });
            bMapGetNameFromCoords(ret.lon, ret.lat, function (ret) {

                apiModelStore.apiSendEvent("locationInfo", ret);
                // console.log(JSON.stringify(ret))
            });
            bMapAddAnnotations(ret.lon, ret.lat);

        }
    });
}

function bMapAddAnnotations(lon, lat) {
    bMap.addAnnotations({
        annotations: [{
            id: 1,
            lon: lon,
            lat: lat,

            draggable: true
        }],

    }, function (ret) {
        if (ret) {
            apiModelStore.apiToast(ret.id);
        }
    });

}

/**
 * 根据经纬度查找地址信息
 * @param lon
 * @param lat
 * @param callback
 */
function bMapGetNameFromCoords(lon, lat, callback) {
    bMap.getNameFromCoords({
        lon: lon,
        lat: lat
    }, function (ret, err) {
        if (ret.status) {
            callback(ret);
            //alert(JSON.stringify(ret));
        }
    });
}

/**
 * 获取地图两点之间的距离
 * @param start
 * @param end
 * @param callback
 */
function bMapGetDistance(start, end, callback) {
    this.start = start;
    this.end = end;
    if (!(start && end)) {
        this.start = {
            lon: 106.486654,
            lat: 29.490295
        };
        this.end = {
            lon: 106.581515,
            lat: 29.615467
        };
    }
    bMap.getDistance({
        start: this.start,
        end: this.end
    }, function (ret) {
        if (ret.status) {
            callback(ret);

        }
    });
}

/*轨迹*/
function locus() {

    var _this = this;
    this.params = {
        locationData:$api.getStorage("location")?JSON.parse($api.getStorage("location")):[],
    };

    /*获取得到轨迹的权限*/
    this.getPermissions = function (callback) {
        apiModelStore.permissions("location").HasPermission(function (ret) {
            if (ret) {
                callback(true);
            } else {
                callback(false);
            }
        });
    };

    /*得到轨迹数据*/
    this.getLocusData = function () {
        bMap.getLocation({
            accuracy: '10m',
            autoStop: true,
            filter: 1,
            enableLocInForeground: true,
            notification: {
                id: 1,   //(必选项) 数字类型；为通知栏notifation设置唯一id，必须大于0
                contentTitle: "掌上盐池",//(必选项) 字符串类型；标题
                contentText: '正在记录您的巡航轨迹', //(必选项) 字符串类型；内容
            }
        }, function (ret, err) {
            if (ret.status) {
                var ddd = $api.getStorage("steps") ? $api.getStorage("steps") : "";
                // console.log("==步数是==========" + ddd);
                // console.log(ret.timestamp + "==当前==" + JSON.stringify(ret));
                var fff = $api.getStorage("location") ? JSON.parse($api.getStorage("location")) : [];
                fff.push(ret);
                _this.saveLocusData(fff);
            } else {
                // console.log(new Date() + "====" + err.code);
            }
        });
    };

    /*停止 位置数据*/
    this.stopLocus = function () {
        bMap.stopLocation();
    };

    /*存储轨迹数据*/
    this.saveLocusData = function (dataL, startTime, interval) {
        this.params = {
            startTime: startTime,//时间戳
            interval: (typeof (interval) == "number" ? interval * 1 : false) || (10 * 60 * 1000),//默认时间 10分钟
            endTime: this.interval + this.start, //结束时间
        };
        // console.log("==总共多少条==" + dataL.length);
        // console.log( "===================分割线==================");
        $api.setStorage("location", JSON.stringify(dataL));
    };

    /*提交数据*/
    this.commitData = function () {
        kit.post(91000, {}, function (ret) {
            // console.log(new Date() + "====" + JSON.stringify(ret));
            $api.setStorage("testData",JSON.stringify(ret));

        });
    };
    return _this;
}

/**
 *
 * @param navCount
 */
function swiperC(navCount) {
    //暂时设计每个slide大小需要一致
    barwidth = 100 //导航粉色条的长度px
    tSpeed = 500 //切换速度300ms
    var navSwiper = new Swiper('#nav', {
        slidesPerView: navCount || 3,
        freeMode: true,
        on: {
            init: function () {
                navSlideWidth = this.slides.eq(0).css('width'); //导航字数需要统一,每个导航宽度一致
                bar = this.$el.find('.bar')
                bar.css('width', navSlideWidth)
                bar.transition(tSpeed)
                navSum = this.slides[this.slides.length - 1].offsetLeft //最后一个slide的位置

                clientWidth = parseInt(this.$wrapperEl.css('width')) //Nav的可视宽度
                navWidth = 0
                for (i = 0; i < this.slides.length; i++) {
                    navWidth += parseInt(this.slides.eq(i).css('width'))
                }

                topBar = this.$el.parents('body').find('#top') //页头

            },

        },
    });

    var pageSwiper = new Swiper('#page', {
        watchSlidesProgress: true,
        resistanceRatio: 0,
        on: {
            touchMove: function () {
                progress = this.progress;
                bar.transition(0);
                bar.transform('translateX(' + navSum * progress + 'px)')
                //粉色255,72,145 灰色51,51,51
                //自定义 95,70,255 灰色51,51,51
                for (i = 0; i < this.slides.length; i++) {
                    slideProgress = this.slides[i].progress;
                    if (Math.abs(slideProgress) < 1) {
                        /*  r = Math.floor((255 - 51) * (1 - Math.pow(Math.abs(slideProgress), 2)) + 51)
                          g = Math.floor((72 - 51) * (1 - Math.pow(Math.abs(slideProgress), 2)) + 51)
                          b = Math.floor((145 - 51) * (1 - Math.pow(Math.abs(slideProgress), 2)) + 51)*/

                        /*  r = Math.floor((95 - 51) * (1 - Math.pow(Math.abs(slideProgress), 2)) + 51)
                          g = Math.floor((70 - 51) * (1 - Math.pow(Math.abs(slideProgress), 2)) + 51)
                          b = Math.floor((255 - 51) * (1 - Math.pow(Math.abs(slideProgress), 2)) + 51)*/
                        r = Math.floor((105 - 51) * (1 - Math.pow(Math.abs(slideProgress), 2)) + 51);
                        g = Math.floor((167 - 51) * (1 - Math.pow(Math.abs(slideProgress), 2)) + 51);
                        b = Math.floor((238 - 51) * (1 - Math.pow(Math.abs(slideProgress), 2)) + 51);
                        navSwiper.slides.eq(i).find('span').css('color', 'rgba(' + r + ',' + g + ',' + b + ',1)');
                    }
                }
            },
            transitionStart: function () {
                activeIndex = this.activeIndex;
                activeSlidePosition = navSwiper.slides[activeIndex].offsetLeft;
                //释放时导航粉色条移动过渡
                bar.transition(tSpeed);
                bar.transform('translateX(' + activeSlidePosition + 'px)');
                //释放时文字变色过渡
                navSwiper.slides.eq(activeIndex).find('span').transition(tSpeed);
                //navSwiper.slides.eq(activeIndex).find('span').css('color', 'rgba(255,72,145,1)')
                navSwiper.slides.eq(activeIndex).find('span').css('color', 'rgba(105,167,238,1)');
                if (activeIndex > 0) {
                    navSwiper.slides.eq(activeIndex - 1).find('span').transition(tSpeed);
                    navSwiper.slides.eq(activeIndex - 1).find('span').css('color', 'rgba(51,51,51,1)');
                    //navSwiper.slides.eq(activeIndex - 1).find('span').css('color', 'rgba(95,70,255,1)')
                }
                if (activeIndex < this.slides.length) {
                    navSwiper.slides.eq(activeIndex + 1).find('span').transition(tSpeed);
                    navSwiper.slides.eq(activeIndex + 1).find('span').css('color', 'rgba(51,51,51,1)');
                    // navSwiper.slides.eq(activeIndex + 1).find('span').css('color', 'rgba(95,70,255,1)')
                }
                //导航居中
                navActiveSlideLeft = navSwiper.slides[activeIndex].offsetLeft; //activeSlide距左边的距离

                navSwiper.setTransition(tSpeed);
                if (navActiveSlideLeft < (clientWidth - parseInt(navSlideWidth)) / 2) {
                    navSwiper.setTranslate(0);
                } else if (navActiveSlideLeft > navWidth - (parseInt(navSlideWidth) + clientWidth) / 2) {
                    navSwiper.setTranslate(clientWidth - navWidth);
                } else {
                    navSwiper.setTranslate((clientWidth - parseInt(navSlideWidth)) / 2 - navActiveSlideLeft);
                }

            },
        }
    });

    navSwiper.$el.on('touchstart', function (e) {
        e.preventDefault(); //去掉按压阴影
    });
    navSwiper.on('tap', function (e) {

        clickIndex = this.clickedIndex;
        clickSlide = this.slides.eq(clickIndex);
        pageSwiper.slideTo(clickIndex, 0);
        this.slides.find('span').css('color', 'rgba(51,51,51,1)');
        //this.slides.find('span').css('color', 'rgba(95,70,255,1)');
        // clickSlide.find('span').css('color', 'rgba(255,72,145,1)');
        //clickSlide.find('span').css('color', 'rgba(202,47,7,1)');
        clickSlide.find('span').css('color', 'rgba(105,167,238,1)');
    });


    //内容滚动
    var scrollSwiper = new Swiper('.scroll', {
        //65是头部的高
        //36是top地址和搜索的高

        slidesOffsetBefore: 36,
        direction: 'vertical',
        freeMode: true,
        slidesPerView: 'auto',

        mousewheel: {
            releaseOnEdges: true,
        },
        /*   on: {
               touchMove: function () {

                   if (this.translate > 72 - 36 && this.translate < 72) {
                       topBar.transform('translateY(' + (this.translate - 72) + 'px)');
                   }

               },
               touchStart: function () {
                   startPosition = this.translate
               },
               touchEnd: function () {
                   topBar.transition(tSpeed)
                   if (this.translate > 36 && this.translate < 72 && this.translate < startPosition) {
                       topBar.transform('translateY(-36px)');
                       for (sc = 0; sc < scrollSwiper.length; sc++) {
                           if (scrollSwiper[sc].translate > 36) {
                               scrollSwiper[sc].setTransition(tSpeed);
                               scrollSwiper[sc].setTranslate(36)
                           }
                       }
                   }
                   if (this.translate > 36 && this.translate < 72 && this.translate > startPosition) {
                       topBar.transform('translateY(0px)');
                       for (sc = 0; sc < scrollSwiper.length; sc++) {
                           if (scrollSwiper[sc].translate < 72 && scrollSwiper[sc].translate > 0) {
                               scrollSwiper[sc].setTransition(tSpeed);
                               scrollSwiper[sc].setTranslate(72)
                           }
                       }

                   }


               },

               transitionStart: function () {

                   topBar.transition(tSpeed)
                   if (this.translate < 72 - 36) {
                       topBar.transform('translateY(-36px)');
                       if (scrollSwiper) {
                           for (sc = 0; sc < scrollSwiper.length; sc++) {
                               if (scrollSwiper[sc].translate > 36) {
                                   scrollSwiper[sc].setTransition(tSpeed);
                                   scrollSwiper[sc].setTranslate(36)
                               }
                           }
                       }

                   } else {
                       topBar.transform('translateY(0px)');

                       if (scrollSwiper) {
                           for (sc = 0; sc < scrollSwiper.length; sc++) {
                               if (scrollSwiper[sc].translate < 72 && scrollSwiper[sc].translate > 0) {
                                   scrollSwiper[sc].setTransition(tSpeed);
                                   scrollSwiper[sc].setTranslate(72)
                               }
                           }
                       }
                   }
               },
           }*/

    });


    //热卖
    var bannerSwiper = new Swiper('.banner', {
        loop: true,
        pagination: {
            el: '.swiper-pagination',
            type: 'fraction',
            renderFraction: function (currentClass, totalClass) {
                return '<span class="' + currentClass + '"></span>' + '/' + '<span class="' + totalClass + '"></span>';
            },
        },
    });


}

//操作状态码
function operationStateCode(stateCode) {
    if ("0" == stateCode) {
        return "未处理";
    } else if ("1" == stateCode) {
        return "已处理";
    }
}

//事件状态码
function eventStateCode(stateCode) {
    if ("001" == stateCode) {
        return "登记";
    } else if ("002" == stateCode) {
        return "上报";
    } else if ("003" == stateCode) {
        return "分派";
    } else if ("004" == stateCode) {
        return "处理";
    } else if ("005" == stateCode) {
        return "下派";
    } else if ("006" == stateCode) {
        return "回退";
    } else if ("007" == stateCode) {
        return "申请延时";
    } else if ("008" == stateCode) {
        return "转办";
    } else if ("009" == stateCode) {
        return "延时批准";
    }
}
