/* ↓↓↓↓   网络配置信息  ↓↓↓↓*/
var global = {
    // ip : "http://218.95.182.38",
    // port : "28080",
    /*ip : "http://192.168.1.106",
    port : "8001",*/
    ip: "http://192.168.1.106",
    port: "8001",//端口号
    timeout: 30,//超时时间
    prefix: "/zhzlpt",//前缀
//	prefix : "/zhzlpt",
    suffix: "/api/service",
};

var globalConfig = function (ip, port, timeout, prefix, suffix) {
    this.data={
        ip : ip || global.ip,
        port : port || global.port,
        timeout : timeout || global.timeout,
        prefix : prefix || global.prefix,
        suffix : suffix || global.suffix,
    };
    this.getIp = function () {
        return this.data.ip;
    };
    this.setIp = function (ip) {
        this.data.ip = ip;
        this.save();
        return this;
    };

    this.getPort = function () {
        return this.data.port;
    };
    this.setPort = function (port) {
        this.data.port = port;
        this.save();
        return this;
    };

    this.getTimeout = function () {
        return this.data.timeout;
    };
    this.setTimeout = function (timeout) {
        this.data.timeout = timeout;
        this.save();
        return this;
    };

    this.getPrefix = function () {
        return this.data.prefix;
    };
    this.setPrefix = function (prefix) {
        this.data.prefix = prefix;
        this.save();
        return this;
    };
    this.getSuffix = function () {
        return this.data.suffix;
    };
    this.setSuffix = function (suffix) {
        this.data.suffix = suffix;
        this.save();
        return this;
    };

    this.save = function () {
        $api.setStorage('globalConfig', this.toString());
    }
    this.getData = function () {
        return this.data;
    };
    this.toString = function () {
        return $api.jsonToStr(this.getData());
    };

    this.read = function () {
        var temp = $api.getStorage('globalConfig');
        if (temp) {
            this.data = $api.strToJson(temp);
            return true;
        }
        return false;
    };

    this.clear = function () {
        this.data = {};
        $api.rmStorage('globalConfig');
    };
    return this;
};
var Global = new globalConfig();
/* ↑↑↑↑↑↑  网络配置信息  ↑↑↑↑↑↑*/

